﻿using System.Text;

namespace Čtvrtý
{
    class Prvek<T>
    {
        private T data;
        private Prvek<T>? další;
        public Prvek(T data = default, Prvek<T>? další = null) 
        { 
            this.Data = data;
            this.Další = další;
        }
        public T Data 
        { 
            get 
            { 
                return data; 
            } 
            set
            {
                this.data = value;
            }
        }

        public Prvek<T>? Další
        {
            get { return další; }
            set { další = value; }
        }
    }

    public class Seznam<T>
    {
        private Prvek<T> hlava, zarážka;
        private int velikost = 0;
        public Seznam()
        {
            hlava = zarážka = new Prvek<T>();
        }

        public void VložNaZačátek(T data)
        {
            hlava = new Prvek<T>(data, hlava);
            velikost++;
        }

        public int Velikost
        {
            get => velikost;
        }

        public bool Prázdný
        {
            get => hlava == zarážka;
        }

        public void OdstraňPrvní()
        {
            if (Prázdný) 
                throw new Exception("Odstraňování z prázdného zásobníku");
            hlava = hlava.Další;
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder("(");
            for(Prvek<T> pom = hlava; pom != zarážka; pom = pom.Další)
            {
                sb.Append(pom.Data.ToString());
                sb.Append(", ");
            }
            sb.Append(")");
            return sb.ToString();
        }


    }
    
    internal class Program
    {
        static void Main(string[] args)
        {
            Seznam<int> s = new();
            Console.WriteLine(s.Prázdný);
            s.VložNaZačátek(10);
            System.Console.WriteLine(s);
            Console.WriteLine(s.Prázdný);
            s.VložNaZačátek(5);
            System.Console.WriteLine(s);
            s.OdstraňPrvní();
            System.Console.WriteLine(s);
        }
    }
}